/*
	ނăzC for WonderSwan
		H.Iwasaki
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/bios.h>
#include <sys/libwwc.h>
#include <resource.h>

#include "myheader.h"

#include "resource.c"

//#define	BIOS_INLINE
//#define	DEBUG

#define	WAIT		30	// WEPE|̃^C~O
#define	WAIT2		5	// |͎̌̓tt[
#define	RNDWAITMAX	10	// EFCg̃_ZlMAX

/* LN^֘Aϐ */
WORD	charTitle[title_height * title_width];
WORD	char32[gu32_height * gu32_width];
WORD	char64[gu64_height * gu64_width];

/* 4FJ[p̃pbg */
unsigned palette[][4] = {
	{ 0x0fff, 0x0f88, 0x0a55, 0x0000 },	// wiC^Cg
	{ 0x0fff, 0x0fca, 0x0a86, 0x0000 },	// bmp32,bmp64p
};


// 񂯂Cw̏
enum { none, gu, choki, pa, up = 1, down, left, right } myStatus, cpuStatus;
// s
enum { win, lose, draw } result;


// V[Ǘpϐ
enum { END, TITLE, READY, JANKEN, JAN_WAIT1, JAN_WAIT2,
		ACCHI, ACC_WAIT1, ACC_WAIT2, RETRY } mode;

int 	key, trg, oldkey;	// L[̓f[^CgKCO̓
int 	gCnt, key;			// t[JE^
int 	num, totalNum, winNum, loseNum;	// 񐔁C񐔁CC
int 	step;				// ڂ̊|
int 	eFlg;				// 1̂Ƃ񂯂ŋ[hON
int 	rndWait;

#ifdef DEBUG
int 	dbg;				// fobOp
#define	debugPrint(dbg)	text_window_init(0, 0, 4, 1, CHAR_DEBUG);\
						text_put_numeric(0, 0, 4, NUM_HEXA, dbg);
#include <bmpsaver.h>		// bmpsaverp
char	fnam[] = "bmp00";
int 	fnamNo = 0;
#endif

void main()
{
#ifdef DEBUG
	bs_set_target(KH_BS_SCREEN1 | KH_BS_SCREEN2 | KH_BS_SPRITE);
	bs_sprite_set_range(0, 1);
#endif
	initSound();
	get_resource(RES_BMP + RES_WAV);
	if( key_press_check() & KEY_X3 )
		chkResource();
	if( key_press_check() & KEY_X2 )
		eFlg = 1;

	srand( sys_get_tick_count() );

	initDisp();

	mode = TITLE;
	gCnt = 0;
	key = 0;

	initTitleScreen();
	title(1);
	while( mode != END ) {
		oldkey = key;
		key = key_press_check();
		trg = (oldkey ^ key) & key;
		switch( mode ) {
			case TITLE:
				switch( title(0) ) {
					case 1:
						initGameScreen();
						clear64();
						clear32();
						num = totalNum = 1;
						winNum = loseNum = 0;
						mode = READY;
						break;
					case 2:
						mode = END;
						break;
				}
				break;
			case READY:
				step = 0;
				myStatus = cpuStatus = none;
				gCnt = 0;
				dispNum();
				rndWait = rand() % RNDWAITMAX;
				mode = JANKEN;
				voice_play( voice[0], PLAY_SINGLE );
				break;
			case JANKEN:
				drawImage64(img[0]);
				janKeyChk();
				if( janken() ) {
					gCnt = 0;
					mode = JAN_WAIT1;
				}
				break;
			case JAN_WAIT1:
				janKeyChk();
				if( gCnt > WAIT2 ) {
					janChk();
					gCnt = 0;
					mode = JAN_WAIT2;
				}
				break;
			case JAN_WAIT2:
				if( gCnt > (WAIT + rndWait) * 2 - WAIT2 ) {
					gCnt = 0;
					if( result == draw ) {
						mode = READY;
					}
					else {
						voice_play( voice[3], PLAY_SINGLE );
						mode = ACCHI;
					}
				}
				break;
			case ACCHI:
				drawImage64(img[0]);
				acchiKeyChk();
				if( acchi() ) {
					gCnt = 0;
					mode = ACC_WAIT1;
				}
				break;
			case ACC_WAIT1:
				acchiKeyChk();
				if( gCnt > WAIT2 ) {
					acchiChk();
					gCnt = 0;
					mode = ACC_WAIT2;
				}
				break;
			case ACC_WAIT2:
				if( gCnt > (WAIT + rndWait) * 2 - WAIT2 ) {
					gCnt = 0;
					if( result == draw ) {
						clear64();
						num++;
						dispNum();
						mode = READY;
					}
					else {
						static char *msg[] = { "@@", "@sk@" };
						if( result == win )
							winNum++;
						else
							loseNum++;
						dispNum();
						text_window_init(8, 11, 4, 1, CHAR_STR);
						text_put_string(0,0,msg[result]);
						mode = RETRY;
					}
				}
				break;
			case RETRY:{
					static char *menu[] = { "x", "߂" };
					switch( selectMenu( 6, 5, 4, 2, menu ) ) {
						case 1:
							initGameScreen();
							num = 1;
							totalNum++;
							mode = READY;
							break;
						case 2:
							initTitleScreen();
							title(1);
							mode = TITLE;
							break;
					}
				}
				break;
		}
#ifdef DEBUG
		debugPrint(dbg);
		if( trg & KEY_Y3 ) {
			sprintf(fnam,"bmp%1d",fnamNo++);
			if( mode == TITLE || mode == RETRY )
				bs_sprite_set_range(0, 1);
			else
				bs_sprite_set_range(0, 0);
			bsc_save_screen(fnam, 0, 0, 224, 144);
		}
#endif
		if( key & KEY_START )
			mode = END;
		sys_wait(1);
		gCnt++;
	}
	closeSound();
	bios_exit();
}

/***********************************************************
	4FJ[p̃pbgݒ
***********************************************************/
void setPalette( int n, unsigned pal[] )
{
	int 	i;

	for( i = 0; i < 4; i++ )
		wwc_palette_set_color(n, i, pal[i]);
}

/***********************************************************
	\֘Ȁݒ
***********************************************************/
void initDisp( void )
{
	lcd_off();	/* fBXvC */

	if( wwc_get_hardarch() == HARDARCH_WSC && !(key_press_check() & KEY_X4) ) {
		wwc_set_color_mode(COLOR_MODE_4COLOR);
		setPalette(0, palette[0]);		/* ƃ^Cgp */
		setPalette(1, palette[1]);		/* char32p */
		setPalette(2, palette[1]);		/* char64p */
		setPalette(12, palette[0]);		/* XvCgppbg */
	}
	else {
		wwc_set_color_mode(COLOR_MODE_GRAYSCALE);
		palette_set_color(0, 0x7420);		/* ƃ^Cgp */
		palette_set_color(1, 0x6420);		/* char32p */
		palette_set_color(2, 0x6420);		/* char64p */
		palette_set_color(12, 0x7420);		/* XvCgppbg */
		lcd_set_color(0x7420, 0xfca8);		/* LCDKf[^ */
	}

	display_control(DCM_SCR1 | DCM_SPR);	/* fBXvCݒ */
	text_set_screen(SCREEN1);

	lcd_on();	/* fBXvC_ */
}

/***********************************************************
	^Cgʂ̏ݒ
***********************************************************/
void initTitleScreen( void )
{
	int 		i;

	// FONT LOAD
	font_set_colordata(CHAR_SPACE, 1, bmp_space);
	font_set_colordata(CHAR_BLK, 1, bmp_block);
	font_set_colordata(CHAR_TITLE, title_width * title_height, bmp_title);
	font_set_colordata(CHAR_ARROW, 1, bmp_arrow);
	font_set_colordata(CHAR_WAKUC, 1, bmp_wakuc);
	font_set_colordata(CHAR_WAKUH, 1, bmp_wakuh);
	font_set_colordata(CHAR_WAKUV, 1, bmp_wakuv);

	for( i = 0; i < title_height * title_width; i++ )
			charTitle[i] = (0 << 9) | (CHAR_TITLE + i);
	for( i = 0; i < gu32_height * gu32_width; i++ )
			char32[i] = (1 << 9) | (CHAR_32 + i);
	for( i = 0; i < gu64_height * gu64_width; i++ )
			char64[i] = (2 << 9) | (CHAR_64 + i);

	// wi&^Cg\
	screen_fill_char(SCREEN1, 0, 0, 28, 32, 0 << 9 | CHAR_BLK);
	screen_set_char(SCREEN1, 9, 5, title_width, title_height, charTitle);
	sprite_set_char(0, 12 << 9 | CHAR_ARROW);
	sprite_set_range(0, 0); 

	text_window_init(11, 11, 4, 1, CHAR_STR);
	text_put_string(0,0,"@Jn@");
	text_window_init(11, 13, 4, 1, CHAR_STR + 4);
	text_put_string(0,0,"@I@");
	screen_set_scroll(SCREEN1, 0, 112);
}

/***********************************************************
	^Cg
		arg:	sw	1̎XN[l̏
		ret:	1(START)/2(EXIT)/0(IĂȂ)
***********************************************************/
int title( int sw )
{
	static int scroll, pos;

	if( sw ) {
		scroll = 112;
		pos = 11;
		return 0;
	}
	if( scroll && !(gCnt % 3) )
		scroll--;
	screen_set_scroll(SCREEN1, 0, scroll);
	if( !scroll ) {
		if( (trg & KEY_UP1) || (trg & KEY_DOWN1) )
			pos ^= 11 ^ 13;
		sprite_set_range(0, 1); 
		sprite_set_location(0, 8 * 10, 8 * pos);
		if( trg & KEY_A )
			return pos / 2 - 4;
	}
	if( trg & KEY_B )
		scroll = 0;
	return 0;
}

/***********************************************************
	Q[ʂ̏ݒ
***********************************************************/
void initGameScreen( void )
{
	int 		i;

	// FONT LOAD
	font_set_colordata(CHAR_SPACE, 1, bmp_space);
	font_set_colordata(CHAR_BLK, 1, bmp_block);
	font_set_colordata(CHAR_TITLE, title_width * title_height, bmp_title);
	font_set_colordata(CHAR_ARROW, 1, bmp_arrow);
	font_set_colordata(CHAR_WAKUC, 1, bmp_wakuc);
	font_set_colordata(CHAR_WAKUH, 1, bmp_wakuh);
	font_set_colordata(CHAR_WAKUV, 1, bmp_wakuv);

	for( i = 0; i < title_height * title_width; i++ )
			charTitle[i] = (0 << 9) | (CHAR_TITLE + i);
	for( i = 0; i < gu32_height * gu32_width; i++ )
			char32[i] = (1 << 9) | (CHAR_32 + i);
	for( i = 0; i < gu64_height * gu64_width; i++ )
			char64[i] = (2 << 9) | (CHAR_64 + i);
	screen_set_scroll(SCREEN1, 0, 0);
	clear32();
	clear64();

	// wi&^Cg\
	screen_fill_char(SCREEN1, 0, 0, 28, 18, 0 << 9 | CHAR_BLK);
	screen_set_char(SCREEN1, 16, 1, title_width, title_height, charTitle);
	screen_set_char(SCREEN1, 8, 13, gu32_height, gu32_width, char32);
	screen_set_char(SCREEN1, 6, 2, gu64_height, gu64_width, char64);
	sprite_set_char(0, 12 << 9 | CHAR_ARROW);
	sprite_set_range(0, 0); 

	text_window_init(8, 11, 4, 1, CHAR_STR);
	text_put_string(0,0,"    ");

	dispNum();
}

/***********************************************************
	s\
***********************************************************/
void dispNum( void )
{
	static char s[9];

	text_window_init(19,6,4,1,CHAR_STR + 4);
	sprintf(s,"%2d", totalNum);
	text_put_string(0,0,s);

	text_window_init(19,8,4,1,CHAR_STR + 8);
	sprintf(s," %2d", winNum);
	text_put_string(0,0,s);

	text_window_init(19,10,4,1,CHAR_STR + 12);
	sprintf(s," %2ds", loseNum);
	text_put_string(0,0,s);

	text_window_init(19,14,4,1,CHAR_STR + 16);
	sprintf(s,"%2d", num);
	text_put_string(0,0,s);
}

/***********************************************************
	32~32(vC[p)̕\̈NA
***********************************************************/
void clear32( void )
{
	int		i;

	for( i = 0; i < 16; i++ )
		font_set_colordata(CHAR_32 + i, 1, bmp_space);
}

/***********************************************************
	64~64(Rs[^p)̕\̈NA
***********************************************************/
void clear64( void )
{
	int		i;

	for( i = 0; i < 64; i++ )
		font_set_colordata(CHAR_64 + i, 1, bmp_space);
}

/***********************************************************
	񂯂̎̃L[̓`FbN
***********************************************************/
void janKeyChk( void )
{
	if( key & KEY_LEFT1 ) {
		myStatus = gu;
		font_set_colordata(CHAR_32, 16, bmp_gu32);
	}
	else if( key & KEY_UP1 ) {
		myStatus = choki;
		font_set_colordata(CHAR_32, 16, bmp_choki32);
	}
	else if( key & KEY_RIGHT1 ) {
		myStatus = pa;
		font_set_colordata(CHAR_32, 16, bmp_pa32);
	}
	else {
		myStatus = none;
		font_set_colordata(CHAR_32, 16, bmp_fwd32);
	}
}

/***********************************************************
	񂯂񏈗
		ret: 0(W܂̓P)/1(|)
***********************************************************/
int janken( void )
{
	static char	*msg[] = { "W", "@P", "@|" };
	if( step > 1 ) {
		if( eFlg ) {				// 񂯂ŋ[ĥƂ
			if( myStatus != none ) // vC[ɏoĂCOM
				cpuStatus = ((myStatus - 1) + 2) % 3 + 1;
			else
				cpuStatus = rand() % 3 + 1;
		}
		else
			cpuStatus = rand() % 3 + 1;

		palette_set_color(2, 0x6420);		/* char64p */

		if( cpuStatus == gu )
			font_set_colordata(CHAR_64, 64, bmp_gu64);
		else if( cpuStatus == choki )
			font_set_colordata(CHAR_64, 64, bmp_choki64);
		else if( cpuStatus == pa )
			font_set_colordata(CHAR_64, 64, bmp_pa64);
		else
			clear64();
		step = 0;
		return 1;
	}

	if( gCnt > WAIT + rndWait ) {
		step++;
		voice_play( voice[step], PLAY_SINGLE );
		gCnt = 0;
	}

	text_window_init(8, 11, 4, 1, CHAR_STR);
	text_put_string(0,0,msg[step]);

	return 0;
}

/***********************************************************
	񂯂̏s
***********************************************************/
void janChk( void )
{
	if( myStatus == none )
		result = lose;
	else
		result = ((myStatus + 1 >> 1) + (myStatus == 2) * 2 + cpuStatus) % 3;
}

/***********************************************************
	ނăzC̎̃L[̓`FbN
***********************************************************/
void acchiKeyChk( void )
{
	if( key & KEY_UP1 ) {
		myStatus = up;
		if( result == win )
			font_set_colordata(CHAR_32, 16, bmp_ue32);
		else
			font_set_colordata(CHAR_32, 16, bmp_up32);
	}
	else if( key & KEY_DOWN1 ) {
		myStatus = down;
		if( result == win )
			font_set_colordata(CHAR_32, 16, bmp_sita32);
		else
			font_set_colordata(CHAR_32, 16, bmp_down32);
	}
	else if( key & KEY_LEFT1 ) {
		myStatus = left;
		if( result == win )
			font_set_colordata(CHAR_32, 16, bmp_hidari32);
		else
			font_set_colordata(CHAR_32, 16, bmp_left32);
	}
	else if( key & KEY_RIGHT1 ) {
		myStatus = right;
		if( result == win )
			font_set_colordata(CHAR_32, 16, bmp_migi32);
		else
			font_set_colordata(CHAR_32, 16, bmp_right32);
	}
	else {
		myStatus = none;
		font_set_colordata(CHAR_32, 16, bmp_fwd32);
	}
}

/***********************************************************
	ނăzC̏
		ret: 0(܂͂ނ)/1(zCb)
***********************************************************/
int acchi( void )
{
	static char	*msg[] = { "", "ނ", "zCbI" };

	if( step > 1 ) {
		cpuStatus = rand() % 4 + 1;

		palette_set_color(2, 0x6420);		/* char64p */

		if( result == win )
			drawImage64(img[cpuStatus]);
		else if( cpuStatus == up )
			font_set_colordata(CHAR_64, 64, bmp_ue64);
		else if( cpuStatus == down )
			font_set_colordata(CHAR_64, 64, bmp_sita64);
		else if( cpuStatus == left )
			font_set_colordata(CHAR_64, 64, bmp_hidari64);
		else if( cpuStatus == right )
			font_set_colordata(CHAR_64, 64, bmp_migi64);
		else
			clear64();
		step = 0;
		return 1;
	}

	if( gCnt > WAIT + rndWait ) {
		step++;
		voice_play( voice[step + 3], PLAY_SINGLE );
		gCnt = 0;
	}

	text_window_init(8, 11, 4, 1, CHAR_STR);
	text_put_string(0,0,msg[step]);

	return 0;
}

/***********************************************************
	ނăzC̏s
***********************************************************/
void acchiChk( void )
{
	if( myStatus == none )
		result = lose;
	else if( myStatus != cpuStatus )
		result = draw;
}

/***********************************************************
	Ij[̕\
***********************************************************/
int selectMenu( int x, int y, int w, int h, char *list[] )
{
	static int 	pos;
	int 	i, n;

	// g\
	n = CHAR_WAKUV;
	for( i = 1; i < h + 1; i++ ) {
		screen_set_char(SCREEN1, x,         y + i, 1, 1, &n);
		screen_set_char(SCREEN1, x + w + 2, y + i, 1, 1, &n);
	}
	n = CHAR_WAKUH;
	for( i = 1; i < w + 2; i++ ) {
		screen_set_char(SCREEN1, x + i, y        , 1, 1, &n);
		screen_set_char(SCREEN1, x + i, y + h + 1, 1, 1, &n);
	}
	n = CHAR_WAKUC;
	screen_set_char(SCREEN1, x        , y        , 1, 1, &n);
	n = CHAR_WAKUC | CFM_FLIP_H;
	screen_set_char(SCREEN1, x + w + 2, y        , 1, 1, &n);
	n = CHAR_WAKUC | CFM_FLIP_V;
	screen_set_char(SCREEN1, x        , y + h + 1, 1, 1, &n);
	n = CHAR_WAKUC | CFM_FLIP_V | CFM_FLIP_H;
	screen_set_char(SCREEN1, x + w + 2, y + h + 1, 1, 1, &n);
	screen_fill_char(SCREEN1, x + 1, y + 1, 1, h, 0 << 9 | CHAR_SPACE);

	text_window_init(x + 2, y + 1, w, h, CHAR_FREE);
	for( i = 0; i < h; i++ )
		text_put_string(0, i, list[i]);
	if( trg & KEY_UP1 )
		pos += h - 1;
	else if( trg & KEY_DOWN1 )
		pos ++;
	pos %= h;
	sprite_set_range(0, 1); 
	sprite_set_location(0, 8 * (x + 1), 8 * (y + 1 + pos));
	if( trg & KEY_A )
		return pos + 1;
	return 0;
}

/***********************************************************
	\[XC[W̕\
***********************************************************/
void drawImage64( res_image_t far *res )
{
	WORD	color = 0;
	int 	i;

	for( i = 3; i >= 0; i-- )
		color = (color << 4) | (res->clrtable[i] >> 5);
	palette_set_color(2, color);

	font_set_colordata(CHAR_64, 64, res + 1);
}

/***********************************************************
	TEh֘A
***********************************************************/
void initSound( void )
{
	text_screen_init();
	if( open_sound_il(&soundIL) != E_FS_SUCCESS ) {
		text_put_string(1,0,"soundIL open error.");
		key_wait();
		bios_exit();
	}
	sounddrv_init();
	sound_open();
}

/***********************************************************
	TEh֘A㏈
***********************************************************/
void closeSound( void )
{
	if( voice_check() )
		voice_stop();
	if( se_check() )
		se_stop();
	if( bgm_check() )
		bgm_stop();
	sound_close();
	sounddrv_release();
}
