#include "il_sound.h"

#define	RES_BMP	5	// BMP\[X̌
#define	RES_WAV	6	// WAV\[X̌

extern res_t far *_resource;
res_music_t far *bgm;
res_voice_t far *voice[RES_WAV];
res_se_t far *se;
res_image_t far *img[RES_BMP];

SoundIL soundIL;



void get_resource( int n )
{
	int 	i;
	res_t far *rsc = _resource;

	for( i = 0; i < n; i++ ) {
		switch( rsc->type ) {
			case RESID_MUSIC:
				bgm = (res_music_t far *)rsc;
				break;
			case RESID_VOICE:
				voice[rsc->id] = (res_voice_t far *)rsc;
				break;
			case RESID_SE:
				se = (res_se_t far *)rsc;
				break;
			case RESID_IMAGE:
				img[rsc->id] = (res_image_t far *)rsc;
				break;
			default:
				text_put_string(1,0,"resource (type,id,size)");
				text_put_numeric(2, 1, 4, NUM_HEXA, rsc->type);
				text_put_numeric(2, 1, 4, NUM_HEXA, rsc->id);
				text_put_numeric(2, 1, 4, NUM_HEXA, rsc->size);
				key_wait();
				bios_exit();
		}
		rsc = MK_FP( FP_SEG( rsc ) + rsc->size, FP_OFF( rsc ) );
	}
}

void chkResource( void )
{
	int 	i;
	static char s[12];

	text_screen_init();
	text_put_string(0,0,"resource check.");
	for( i = 0; i < RES_BMP; i++ ) {
		sprintf(s, "img[%d] %s", i, img[i] ? "OK" : "NULL");
		text_put_string(1, i + 1, s);
	}
	for( i = 0; i < RES_WAV; i++ ) {
		sprintf(s, "wav[%d] %s", i, voice[i] ? "OK" : "NULL");
		text_put_string(1, i + 1 + RES_BMP, s);
	}
	key_wait();
}
